Class: Bundler::CLI::Outdated

Inherits:
Object
  • Object
show all
Defined in:
lib/bundler/cli/outdated.rb

Instance Attribute Summary collapse

Instance Method Summary collapse

Constructor Details

#initialize(options, gems) ⇒ Outdated

Returns a new instance of Outdated



7
8
9
10
# File 'lib/bundler/cli/outdated.rb', line 7

def initialize(options, gems)
  @options = options
  @gems = gems
end

Instance Attribute Details

#gemsObject (readonly)

Returns the value of attribute gems



5
6
7
# File 'lib/bundler/cli/outdated.rb', line 5

def gems
  @gems
end

#optionsObject (readonly)

Returns the value of attribute options



5
6
7
# File 'lib/bundler/cli/outdated.rb', line 5

def options
  @options
end

Instance Method Details

#runObject



12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
86
87
88
89
90
91
92
93
94
95
96
97
98
99
100
101
102
103
104
105
106
107
108
109
110
111
112
113
114
115
116
117
118
119
120
121
122
123
124
125
126
127
128
129
130
131
132
133
134
135
136
137
138
139
140
141
142
143
144
145
146
147
148
149
150
151
152
153
154
155
156
157
158
159
160
# File 'lib/bundler/cli/outdated.rb', line 12

def run
  check_for_deployment_mode

  sources = Array(options[:source])

  gems.each do |gem_name|
    Bundler::CLI::Common.select_spec(gem_name)
  end

  Bundler.definition.validate_runtime!
  current_specs = Bundler.ui.silence { Bundler.definition.resolve }
  current_dependencies = {}
  Bundler.ui.silence do
    Bundler.load.dependencies.each do |dep|
      current_dependencies[dep.name] = dep
    end
  end

  definition = if gems.empty? && sources.empty?
    # We're doing a full update
    Bundler.definition(true)
  else
    Bundler.definition(:gems => gems, :sources => sources)
  end

  Bundler::CLI::Common.configure_gem_version_promoter(
    Bundler.definition,
    options
  )

  # the patch level options imply strict is also true. It wouldn't make
  # sense otherwise.
  strict = options[:strict] ||
    Bundler::CLI::Common.patch_level_options(options).any?

  filter_options_patch = options.keys &
    %w[filter-major filter-minor filter-patch]

  definition_resolution = proc do
    options[:local] ? definition.resolve_with_cache! : definition.resolve_remotely!
  end

  if options[:parseable]
    Bundler.ui.silence(&definition_resolution)
  else
    definition_resolution.call
  end

  Bundler.ui.info ""
  outdated_gems_by_groups = {}
  outdated_gems_list = []

  # Loop through the current specs
  gemfile_specs, dependency_specs = current_specs.partition do |spec|
    current_dependencies.key? spec.name
  end

  (gemfile_specs + dependency_specs).sort_by(&:name).each do |current_spec|
    next if !gems.empty? && !gems.include?(current_spec.name)

    dependency = current_dependencies[current_spec.name]
    active_spec = retrieve_active_spec(strict, definition, current_spec)

    next if active_spec.nil?
    if filter_options_patch.any?
      update_present = update_present_via_semver_portions(current_spec, active_spec, options)
      next unless update_present
    end

    gem_outdated = Gem::Version.new(active_spec.version) > Gem::Version.new(current_spec.version)
    next unless gem_outdated || (current_spec.git_version != active_spec.git_version)
    groups = nil
    if dependency && !options[:parseable]
      groups = dependency.groups.join(", ")
    end

    outdated_gems_list << { :active_spec => active_spec,
                            :current_spec => current_spec,
                            :dependency => dependency,
                            :groups => groups }

    outdated_gems_by_groups[groups] ||= []
    outdated_gems_by_groups[groups] << { :active_spec => active_spec,
                                         :current_spec => current_spec,
                                         :dependency => dependency,
                                         :groups => groups }
  end

  if outdated_gems_list.empty?
    display_nothing_outdated_message(filter_options_patch)
  else
    unless options[:parseable]
      if options[:pre]
        Bundler.ui.info "Outdated gems included in the bundle (including " \
          "pre-releases):"
      else
        Bundler.ui.info "Outdated gems included in the bundle:"
      end
    end

    options_include_groups = [:group, :groups].select do |v|
      options.keys.include?(v.to_s)
    end

    if options_include_groups.any?
      ordered_groups = outdated_gems_by_groups.keys.compact.sort
      [nil, ordered_groups].flatten.each do |groups|
        gems = outdated_gems_by_groups[groups]
        contains_group = if groups
          groups.split(",").include?(options[:group])
        else
          options[:group] == "group"
        end

        next if (!options[:groups] && !contains_group) || gems.nil?

        unless options[:parseable]
          if groups
            Bundler.ui.info "===== Group #{groups} ====="
          else
            Bundler.ui.info "===== Without group ====="
          end
        end

        gems.each do |gem|
          print_gem(
            gem[:current_spec],
            gem[:active_spec],
            gem[:dependency],
            groups,
            options_include_groups.any?
          )
        end
      end
    else
      outdated_gems_list.each do |gem|
        print_gem(
          gem[:current_spec],
          gem[:active_spec],
          gem[:dependency],
          gem[:groups],
          options_include_groups.any?
        )
      end
    end

    exit 1
  end
end